"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.invoke = void 0;
process.env.FORCE_COLOR = "0";
const nanolru_1 = __importDefault(require("nanolru"));
const path_1 = require("path");
const path_2 = __importDefault(require("path"));
const configCache = new nanolru_1.default({ max: 20, maxAge: 60000 });
async function resolveConfig(prettier, cwd, filepath) {
    let v = configCache.get(cwd);
    if (!v) {
        v = await prettier.resolveConfig(filepath, {
            editorconfig: true,
            useCache: false,
        });
        if (!v && process.env.PRETTIERD_DEFAULT_CONFIG) {
            console.log(process.env.PRETTIERD_DEFAULT_CONFIG);
            v = await prettier.resolveConfig(path_1.dirname(process.env.PRETTIERD_DEFAULT_CONFIG), {
                config: process.env.PRETTIERD_DEFAULT_CONFIG,
                editorconfig: true,
                useCache: false,
            });
        }
        if (v) {
            configCache.set(cwd, v);
        }
    }
    return {
        ...v,
        filepath,
    };
}
async function resolvePrettier(cwd) {
    return Promise.resolve().then(() => __importStar(require(require.resolve("prettier", { paths: [cwd] })))).catch(() => Promise.resolve().then(() => __importStar(require("prettier"))));
}
function resolveFile(cwd, fileName) {
    if (path_2.default.isAbsolute(fileName)) {
        return [fileName, fileName];
    }
    return [cwd, path_2.default.join(cwd, fileName)];
}
async function run(cwd, args, text) {
    const fileName = args[0] === "--no-color" ? args[1] : args[0];
    const [cacheKey, fullPath] = resolveFile(cwd, fileName);
    const prettier = await resolvePrettier(cwd);
    const options = await resolveConfig(prettier, cacheKey, fullPath);
    return prettier.format(text, options);
}
function invoke(cwd, args, text, _mtime, cb) {
    run(cwd, args, text)
        .then((resp) => void cb(undefined, resp))
        .catch((error) => void cb(error));
}
exports.invoke = invoke;
